Integrate with the Connect API - Legacy Access
Integrations developed prior to the availability of the Developer Console will generally leverage the API versions listed below:
| API | Version |
|---|---|
| Core | 2.0 |
| Core Account | v1 |
| Issues | v1 |
| Model | v1 |
| Model Feature | 1.0 |
| Organizer | v1 |
| Property Set | v1 |
| Topics | v2 |
API Deprecation Timeline
Section titled “API Deprecation Timeline”If not otherwise indicated, no ETA is available yet on when these older API versions will be deprecated.
Access
Section titled “Access”Open the Trimble Connect for Browser application and complete the user sign-up process.
Terms of Service
Section titled “Terms of Service”You must agree to the Terms of Service to use Connect services.
Register Application
Section titled “Register Application”To be provided legacy access credentials, use this form.
After registration, we will provide you with a Consumer Key, Consumer secret, Application Name & Callback Url, which you will use to authenticate users with Trimble Identity in order to use the Trimble Connect APIs.
Get Access Token
Section titled “Get Access Token”Once the above steps are completed, you should have the following details:
- Trimble Identity username (email)
- Trimble Identity password
- Application Name
- Application Consumer Key
- Application Consumer Secret
- Application Redirect/Callback Uri
Authentication
Section titled “Authentication”To use Trimble Connect APIs you need a user-context OAuth access token from Trimble Identity.
See the Authentication Guide for information on how to authenticate users with Trimble Identity using OAuth. We recommend using the Authorization Code with PKCE authentication flow, but plain Authorization Code flow will also work.
After successful authentication you’ll receive an access token that can be used to authorize Trimble Connect API calls.
Non-interactive Authentication
Section titled “Non-interactive Authentication”Trimble Connect does not support OAuth Client Credentials tokens, so non-interactive applications/integrations must use a different authentication approach:
- Use the Authorization Code flow for initial authentication
- The initial authentication is interactive, after which you will receive the access and refresh tokens
- Provision the non-interactive application with the tokens
- Properly manage the tokens within your non-interactive application. The tokens should be refreshed as needed, with a maximum refresh interval of 9 days to keep the session alive.
Use Connect Services
Section titled “Use Connect Services”To use the Trimble Connect APIs, you must include an Authorization header to your requests. Replace access_token with the actual value you got from the previous authentication step.
Example 1: You can use the get user details API to validate that your authentication has been successful
GET https://app.connect.trimble.com/tc/api/2.0/users/meAuthorization: Bearer access_tokenExample 2: You can get the list of projects in the US region with
GET https://app.connect.trimble.com/tc/api/2.0/projects?fullyLoaded=falseAuthorization: Bearer access_tokenAuthorization
Section titled “Authorization”Trimble Connect API methods must be called as an authenticated Trimble Identity (TID) user. You need to complete the steps on this page to be able to call the APIs.
Access to data is based on the authenticated user making the Connect API calls.
Most data is organized under a project and, project membership grants users access to project data. Read/write access to project data is separately controlled by permissions. Project admins have full access project’s data, while Account admins have full visibility into projects created under an account.
For more details, see the Concepts section.
Regions
Section titled “Regions”Connect API offers regional endpoints that you can use to make your requests. The resources in each region are independent of similar resources in other regions.
Regions can be discovered by calling the /regions endpoint of the master region. Use the origin field value to determine the base URL to make API calls to a specific region.
The base URLs of other regional Trimble Connect services are also returned for each region, and should always be discovered using this API. Proper use of region discovery will prevent issues if/when new Connect regions are introduced, or if the service endpoints change.